Index: sansmodels/src/sans/models/HardsphereStructure.py
===================================================================
--- sansmodels/src/sans/models/HardsphereStructure.py	(revision 1bbf2acba708b1e85248ea1f238819e42181d2ab)
+++ sansmodels/src/sans/models/HardsphereStructure.py	(revision 1bbf2acba708b1e85248ea1f238819e42181d2ab)
@@ -0,0 +1,99 @@
+#!/usr/bin/env python
+"""
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+"""
+
+""" Provide functionality for a C extension model
+
+	WARNING: THIS FILE WAS GENERATED BY WRAPPERGENERATOR.PY
+ 	         DO NOT MODIFY THIS FILE, MODIFY c:\ECLPS\workspace\trunk\sansmodels\src\sans\models\c_extensions\Hardsphere.h
+ 	         AND RE-RUN THE GENERATOR SCRIPT
+
+"""
+
+from sans.models.BaseComponent import BaseComponent
+from sans_extension.c_models import CHardsphereStructure
+import copy    
+    
+class HardsphereStructure(CHardsphereStructure, BaseComponent):
+    """ Class that evaluates a HardsphereStructure model. 
+    	This file was auto-generated from c:\ECLPS\workspace\trunk\sansmodels\src\sans\models\c_extensions\Hardsphere.h.
+    	Refer to that file and the structure it contains
+    	for details of the model.
+    	List of default parameters:
+         radius          = 50.0 A
+         volfraction     = 0.2 
+
+    """
+        
+    def __init__(self):
+        """ Initialization """
+        
+        # Initialize BaseComponent first, then sphere
+        BaseComponent.__init__(self)
+        CHardsphereStructure.__init__(self)
+        
+        ## Name of the model
+        self.name = "HardsphereStructure"
+        ## Model description
+        self.description ="""Structure factor for interacting particles:
+		
+		The interparticle potential is
+		
+		U(r)= inf   , r < 2R
+		= 0     , r >= 2R
+		
+		R: radius of the Hardsphere particle
+		V:The volume fraction
+		
+		Ref: Percus., J. K.,etc., J. Phy. Rev.
+		1958, 110, 1."""
+       
+		## Parameter details [units, min, max]
+        self.details = {}
+        self.details['radius'] = ['A', None, None]
+        self.details['volfraction'] = ['', None, None]
+
+		## fittable parameters
+        self.fixed=['radius.width']
+   
+    def clone(self):
+        """ Return a identical copy of self """
+        return self._clone(HardsphereStructure())   
+   
+    def run(self, x = 0.0):
+        """ Evaluate the model
+            @param x: input q, or [q,phi]
+            @return: scattering function P(q)
+        """
+        
+        return CHardsphereStructure.run(self, x)
+   
+    def runXY(self, x = 0.0):
+        """ Evaluate the model in cartesian coordinates
+            @param x: input q, or [qx, qy]
+            @return: scattering function P(q)
+        """
+        
+        return CHardsphereStructure.runXY(self, x)
+        
+    def set_dispersion(self, parameter, dispersion):
+        """
+            Set the dispersion object for a model parameter
+            @param parameter: name of the parameter [string]
+            @dispersion: dispersion object of type DispersionModel
+        """
+        return CHardsphereStructure.set_dispersion(self, parameter, dispersion.cdisp)
+        
+   
+# End of file
Index: sansmodels/src/sans/models/HayterMSAStructure.py
===================================================================
--- sansmodels/src/sans/models/HayterMSAStructure.py	(revision 1bbf2acba708b1e85248ea1f238819e42181d2ab)
+++ sansmodels/src/sans/models/HayterMSAStructure.py	(revision 1bbf2acba708b1e85248ea1f238819e42181d2ab)
@@ -0,0 +1,108 @@
+#!/usr/bin/env python
+"""
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+"""
+
+""" Provide functionality for a C extension model
+
+	WARNING: THIS FILE WAS GENERATED BY WRAPPERGENERATOR.PY
+ 	         DO NOT MODIFY THIS FILE, MODIFY c:\ECLPS\workspace\trunk\sansmodels\src\sans\models\c_extensions\HayterMSA.h
+ 	         AND RE-RUN THE GENERATOR SCRIPT
+
+"""
+
+from sans.models.BaseComponent import BaseComponent
+from sans_extension.c_models import CHayterMSAStructure
+import copy    
+    
+class HayterMSAStructure(CHayterMSAStructure, BaseComponent):
+    """ Class that evaluates a HayterMSAStructure model. 
+    	This file was auto-generated from c:\ECLPS\workspace\trunk\sansmodels\src\sans\models\c_extensions\HayterMSA.h.
+    	Refer to that file and the structure it contains
+    	for details of the model.
+    	List of default parameters:
+         radius          = 20.75 A
+         charge          = 19.0 
+         volfraction     = 0.0192 
+         temperature     = 318.16 K
+         saltconc        = 0.0 
+         dielectconst    = 71.08 
+
+    """
+        
+    def __init__(self):
+        """ Initialization """
+        
+        # Initialize BaseComponent first, then sphere
+        BaseComponent.__init__(self)
+        CHayterMSAStructure.__init__(self)
+        
+        ## Name of the model
+        self.name = "HayterMSAStructure"
+        ## Model description
+        self.description ="""To calculate the structure factor (the Fourier transform
+		of the pair correlation function g(r)) for
+		a system of charged, spheroidal objects in
+		a dielectric medium. When combined with an
+		appropriate form factor, this allows
+		for inclusion of the interparticle
+		interference effects due to screened coulomb
+		repulsion between charged particles.
+		(note: charge > 0 required.)
+		
+		Ref: JP Hansen and JB Hayter, Molecular
+		Physics 46, 651-656 (1982).
+		"""
+       
+		## Parameter details [units, min, max]
+        self.details = {}
+        self.details['radius'] = ['A', None, None]
+        self.details['charge'] = ['', None, None]
+        self.details['volfraction'] = ['', None, None]
+        self.details['temperature'] = ['K', None, None]
+        self.details['saltconc'] = ['', None, None]
+        self.details['dielectconst'] = ['', None, None]
+
+		## fittable parameters
+        self.fixed=['radius.width']
+   
+    def clone(self):
+        """ Return a identical copy of self """
+        return self._clone(HayterMSAStructure())   
+   
+    def run(self, x = 0.0):
+        """ Evaluate the model
+            @param x: input q, or [q,phi]
+            @return: scattering function P(q)
+        """
+        
+        return CHayterMSAStructure.run(self, x)
+   
+    def runXY(self, x = 0.0):
+        """ Evaluate the model in cartesian coordinates
+            @param x: input q, or [qx, qy]
+            @return: scattering function P(q)
+        """
+        
+        return CHayterMSAStructure.runXY(self, x)
+        
+    def set_dispersion(self, parameter, dispersion):
+        """
+            Set the dispersion object for a model parameter
+            @param parameter: name of the parameter [string]
+            @dispersion: dispersion object of type DispersionModel
+        """
+        return CHayterMSAStructure.set_dispersion(self, parameter, dispersion.cdisp)
+        
+   
+# End of file
Index: sansmodels/src/sans/models/SquareWellStructure.py
===================================================================
--- sansmodels/src/sans/models/SquareWellStructure.py	(revision 1bbf2acba708b1e85248ea1f238819e42181d2ab)
+++ sansmodels/src/sans/models/SquareWellStructure.py	(revision 1bbf2acba708b1e85248ea1f238819e42181d2ab)
@@ -0,0 +1,105 @@
+#!/usr/bin/env python
+"""
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+"""
+
+""" Provide functionality for a C extension model
+
+	WARNING: THIS FILE WAS GENERATED BY WRAPPERGENERATOR.PY
+ 	         DO NOT MODIFY THIS FILE, MODIFY c:\ECLPS\workspace\trunk\sansmodels\src\sans\models\c_extensions\SquareWell.h
+ 	         AND RE-RUN THE GENERATOR SCRIPT
+
+"""
+
+from sans.models.BaseComponent import BaseComponent
+from sans_extension.c_models import CSquareWellStructure
+import copy    
+    
+class SquareWellStructure(CSquareWellStructure, BaseComponent):
+    """ Class that evaluates a SquareWellStructure model. 
+    	This file was auto-generated from c:\ECLPS\workspace\trunk\sansmodels\src\sans\models\c_extensions\SquareWell.h.
+    	Refer to that file and the structure it contains
+    	for details of the model.
+    	List of default parameters:
+         radius          = 50.0 A
+         volfraction     = 0.04 
+         welldepth       = 1.5 kT
+         wellwidth       = 1.2 
+
+    """
+        
+    def __init__(self):
+        """ Initialization """
+        
+        # Initialize BaseComponent first, then sphere
+        BaseComponent.__init__(self)
+        CSquareWellStructure.__init__(self)
+        
+        ## Name of the model
+        self.name = "SquareWellStructure"
+        ## Model description
+        self.description =""" Structure Factor for interacting particles:
+		
+		The interaction potential is
+		
+		U(r)= inf   , r < 2R
+		= -d    , 2R <= r <=2Rw
+		= 0     , r >= 2Rw
+		
+		R: radius (A)of the particle, v: volume fraction
+		d: well depth
+		w: well width; multiples of the particle diameter
+		
+		Ref: Sharma, R. V.; Sharma, K. C., Physica,
+		1977, 89A, 213."""
+       
+		## Parameter details [units, min, max]
+        self.details = {}
+        self.details['radius'] = ['A', None, None]
+        self.details['volfraction'] = ['', None, None]
+        self.details['welldepth'] = ['kT', None, None]
+        self.details['wellwidth'] = ['', None, None]
+
+		## fittable parameters
+        self.fixed=['radius.width']
+   
+    def clone(self):
+        """ Return a identical copy of self """
+        return self._clone(SquareWellStructure())   
+   
+    def run(self, x = 0.0):
+        """ Evaluate the model
+            @param x: input q, or [q,phi]
+            @return: scattering function P(q)
+        """
+        
+        return CSquareWellStructure.run(self, x)
+   
+    def runXY(self, x = 0.0):
+        """ Evaluate the model in cartesian coordinates
+            @param x: input q, or [qx, qy]
+            @return: scattering function P(q)
+        """
+        
+        return CSquareWellStructure.runXY(self, x)
+        
+    def set_dispersion(self, parameter, dispersion):
+        """
+            Set the dispersion object for a model parameter
+            @param parameter: name of the parameter [string]
+            @dispersion: dispersion object of type DispersionModel
+        """
+        return CSquareWellStructure.set_dispersion(self, parameter, dispersion.cdisp)
+        
+   
+# End of file
Index: sansmodels/src/sans/models/StickyHSStructure.py
===================================================================
--- sansmodels/src/sans/models/StickyHSStructure.py	(revision 1bbf2acba708b1e85248ea1f238819e42181d2ab)
+++ sansmodels/src/sans/models/StickyHSStructure.py	(revision 1bbf2acba708b1e85248ea1f238819e42181d2ab)
@@ -0,0 +1,107 @@
+#!/usr/bin/env python
+"""
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+"""
+
+""" Provide functionality for a C extension model
+
+	WARNING: THIS FILE WAS GENERATED BY WRAPPERGENERATOR.PY
+ 	         DO NOT MODIFY THIS FILE, MODIFY c:\ECLPS\workspace\trunk\sansmodels\src\sans\models\c_extensions\StickyHS.h
+ 	         AND RE-RUN THE GENERATOR SCRIPT
+
+"""
+
+from sans.models.BaseComponent import BaseComponent
+from sans_extension.c_models import CStickyHSStructure
+import copy    
+    
+class StickyHSStructure(CStickyHSStructure, BaseComponent):
+    """ Class that evaluates a StickyHSStructure model. 
+    	This file was auto-generated from c:\ECLPS\workspace\trunk\sansmodels\src\sans\models\c_extensions\StickyHS.h.
+    	Refer to that file and the structure it contains
+    	for details of the model.
+    	List of default parameters:
+         radius          = 50.0 A
+         volfraction     = 0.1 
+         perturb         = 0.05 
+         stickiness      = 0.2 
+
+    """
+        
+    def __init__(self):
+        """ Initialization """
+        
+        # Initialize BaseComponent first, then sphere
+        BaseComponent.__init__(self)
+        CStickyHSStructure.__init__(self)
+        
+        ## Name of the model
+        self.name = "StickyHSStructure"
+        ## Model description
+        self.description =""" Structure Factor for interacting particles:
+		
+		The interaction potential is
+		
+		U(r)= inf , r < 2R
+		= -Uo  , 2R < r < 2R + w
+		= 0   , r >= 2R +w
+		
+		R: radius of the hardsphere
+		stickiness = [exp(Uo/kT)]/(12*perturb)
+		perturb = w/(w+ 2R) , 0.01 =< w <= 0.1
+		w: The width of the square well ,w > 0
+		v: The volume fraction , v > 0
+		
+		Ref: Menon, S. V. G.,et.al., J. Chem. Phys.,
+		1991, 95(12), 9186-9190."""
+       
+		## Parameter details [units, min, max]
+        self.details = {}
+        self.details['radius'] = ['A', None, None]
+        self.details['volfraction'] = ['', None, None]
+        self.details['perturb'] = ['', None, None]
+        self.details['stickiness'] = ['', None, None]
+
+		## fittable parameters
+        self.fixed=['radius.width']
+   
+    def clone(self):
+        """ Return a identical copy of self """
+        return self._clone(StickyHSStructure())   
+   
+    def run(self, x = 0.0):
+        """ Evaluate the model
+            @param x: input q, or [q,phi]
+            @return: scattering function P(q)
+        """
+        
+        return CStickyHSStructure.run(self, x)
+   
+    def runXY(self, x = 0.0):
+        """ Evaluate the model in cartesian coordinates
+            @param x: input q, or [qx, qy]
+            @return: scattering function P(q)
+        """
+        
+        return CStickyHSStructure.runXY(self, x)
+        
+    def set_dispersion(self, parameter, dispersion):
+        """
+            Set the dispersion object for a model parameter
+            @param parameter: name of the parameter [string]
+            @dispersion: dispersion object of type DispersionModel
+        """
+        return CStickyHSStructure.set_dispersion(self, parameter, dispersion.cdisp)
+        
+   
+# End of file