Index: src/sas/qtgui/Perspectives/Fitting/GPUOptions.py
===================================================================
--- src/sas/qtgui/Perspectives/Fitting/GPUOptions.py	(revision 37be27f17369e69b11e275a0d5df62b5f2c53a34)
+++ src/sas/qtgui/Perspectives/Fitting/GPUOptions.py	(revision 98633434418f1605273227a5a30d24ad28fcf27a)
@@ -6,4 +6,5 @@
 import platform
 
+import sas.qtgui.Utilities.GuiUtils as GuiUtils
 from PyQt4 import QtGui, QtCore, QtWebKit
 from sas.qtgui.Perspectives.Fitting.UI.GPUOptionsUI import Ui_GPUOptions
@@ -38,4 +39,5 @@
         self.setupUi(self)
         self.addOpenCLOptions()
+        self.setFixedSize(self.size())
         self.createLinks()
 
@@ -61,5 +63,5 @@
             # Expand group and shift items down as more are added
             self.openCLCheckBoxGroup.resize(391, 60 + i)
-            self.label.setGeometry(QtCore.QRect(20, 90 + i, 391, 37))
+            self.warningMessage.setGeometry(QtCore.QRect(20, 90 + i, 391, 37))
             self.okButton.setGeometry(QtCore.QRect(20, 127 + i, 93, 28))
             self.resetButton.setGeometry(QtCore.QRect(120, 127 + i, 93, 28))
@@ -73,8 +75,8 @@
         Link user interactions to function calls
         """
-        self.testButton.clicked.connect(lambda: self.testButtonClicked())
-        self.helpButton.clicked.connect(lambda: self.helpButtonClicked())
+        self.testButton.clicked.connect(self.testButtonClicked)
+        self.helpButton.clicked.connect(self.helpButtonClicked)
         for item in self.openCLCheckBoxGroup.findChildren(QtGui.QCheckBox):
-            item.clicked.connect(lambda: self.checked())
+            item.clicked.connect(self.checked)
 
     def checked(self):
@@ -151,6 +153,4 @@
         }
 
-        msg_info = 'OpenCL tests results'
-
         msg = str(tests_completed) + ' tests completed.\n'
         if len(failures) > 0:
@@ -172,5 +172,5 @@
             msg += "\nOpenCL driver: "
             msg += json.dumps(info['opencl']) + "\n"
-        GPUTestResults(self, msg, msg_info)
+        GPUTestResults(self, msg)
 
     def helpButtonClicked(self):
@@ -178,8 +178,8 @@
         Open the help menu when the help button is clicked
         """
-        tree_location = "user/sasgui/perspectives/fitting/gpu_setup.html"
-        anchor = "#device-selection"
+        help_location = GuiUtils.HELP_DIRECTORY_LOCATION
+        help_location += "/user/sasgui/perspectives/fitting/gpu_setup.html"
+        help_location += "#device-selection"
         self.helpView = QtWebKit.QWebView()
-        help_location = tree_location + anchor
         self.helpView.load(QtCore.QUrl(help_location))
         self.helpView.show()
@@ -211,8 +211,9 @@
     OpenCL Dialog to modify the OpenCL options
     """
-    def __init__(self, parent, msg, title):
+    def __init__(self, parent, msg):
         super(GPUTestResults, self).__init__(parent)
         self.setupUi(self)
         self.resultsText.setText(_translate("GPUTestResults", msg, None))
+        self.setFixedSize(self.size())
         self.open()
 
@@ -223,24 +224,24 @@
     """
     clinfo = []
-    platforms = []
+    cl_platforms = []
     try:
         import pyopencl as cl
-        platforms = cl.get_platforms()
+        cl_platforms = cl.get_platforms()
     except ImportError:
         print("pyopencl import failed. Using only CPU computations")
 
     p_index = 0
-    for platform in platforms:
+    for cl_platform in cl_platforms:
         d_index = 0
-        devices = platform.get_devices()
-        for device in devices:
-            if len(devices) > 1 and len(platforms) > 1:
+        cl_platforms = cl_platform.get_devices()
+        for cl_platform in cl_platforms:
+            if len(cl_platforms) > 1 and len(cl_platforms) > 1:
                 combined_index = ":".join([str(p_index), str(d_index)])
-            elif len(platforms) > 1:
+            elif len(cl_platforms) > 1:
                 combined_index = str(p_index)
             else:
                 combined_index = str(d_index)
-            clinfo.append((combined_index, ":".join([platform.name,
-                                                     device.name])))
+            clinfo.append((combined_index, ":".join([cl_platform.name,
+                                                     cl_platform.name])))
             d_index += 1
         p_index += 1
Index: src/sas/qtgui/Perspectives/Fitting/UI/GPUOptionsUI.ui
===================================================================
--- src/sas/qtgui/Perspectives/Fitting/UI/GPUOptionsUI.ui	(revision ced1bff8b21c8df3cf33ca1d0d50b573f7de9252)
+++ src/sas/qtgui/Perspectives/Fitting/UI/GPUOptionsUI.ui	(revision 98633434418f1605273227a5a30d24ad28fcf27a)
@@ -7,10 +7,16 @@
     <x>0</x>
     <y>0</y>
-    <width>440</width>
-    <height>211</height>
+    <width>438</width>
+    <height>206</height>
    </rect>
   </property>
+  <property name="sizePolicy">
+   <sizepolicy hsizetype="Fixed" vsizetype="Fixed">
+    <horstretch>0</horstretch>
+    <verstretch>0</verstretch>
+   </sizepolicy>
+  </property>
   <property name="windowTitle">
-   <string>Dialog</string>
+   <string>OpenCL Options</string>
   </property>
   <widget class="QPushButton" name="testButton">
@@ -82,5 +88,5 @@
    </property>
   </widget>
-  <widget class="QLabel" name="label">
+  <widget class="QLabel" name="warningMessage">
    <property name="geometry">
     <rect>
@@ -114,5 +120,5 @@
     <hint type="sourcelabel">
      <x>66</x>
-     <y>153</y>
+     <y>183</y>
     </hint>
     <hint type="destinationlabel">
@@ -129,6 +135,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>166</x>
-     <y>153</y>
+     <x>266</x>
+     <y>183</y>
     </hint>
     <hint type="destinationlabel">
Index: src/sas/qtgui/Perspectives/Fitting/UI/GPUTestResultsUI.ui
===================================================================
--- src/sas/qtgui/Perspectives/Fitting/UI/GPUTestResultsUI.ui	(revision ced1bff8b21c8df3cf33ca1d0d50b573f7de9252)
+++ src/sas/qtgui/Perspectives/Fitting/UI/GPUTestResultsUI.ui	(revision 98633434418f1605273227a5a30d24ad28fcf27a)
@@ -12,7 +12,7 @@
   </property>
   <property name="windowTitle">
-   <string>Dialog</string>
+   <string>OpenCL Test Results</string>
   </property>
-  <widget class="QDialogButtonBox" name="buttonBox">
+  <widget class="QDialogButtonBox" name="okButton">
    <property name="geometry">
     <rect>
@@ -33,5 +33,5 @@
    </property>
   </widget>
-  <widget class="QLabel" name="label">
+  <widget class="QLabel" name="falingTestsNoOpenCL">
    <property name="geometry">
     <rect>
@@ -49,5 +49,5 @@
    </property>
   </widget>
-  <widget class="QLabel" name="label_2">
+  <widget class="QLabel" name="howToReportIssues">
    <property name="geometry">
     <rect>
@@ -76,4 +76,10 @@
      <height>321</height>
     </rect>
+   </property>
+   <property name="sizePolicy">
+    <sizepolicy hsizetype="Fixed" vsizetype="Fixed">
+     <horstretch>0</horstretch>
+     <verstretch>0</verstretch>
+    </sizepolicy>
    </property>
    <property name="title">
@@ -116,5 +122,5 @@
  <connections>
   <connection>
-   <sender>buttonBox</sender>
+   <sender>okButton</sender>
    <signal>accepted()</signal>
    <receiver>GPUTestResults</receiver>
@@ -132,5 +138,5 @@
   </connection>
   <connection>
-   <sender>buttonBox</sender>
+   <sender>okButton</sender>
    <signal>rejected()</signal>
    <receiver>GPUTestResults</receiver>